# Generated by Django 4.2.16 on 2024-10-13 12:28

from django.db import migrations, models, transaction

from bpp.util import pbar


@transaction.atomic
def skopiuj_dyscypliny_zrodel(apps, schema_editor):
    Dyscyplina_Zrodla = apps.get_model("bpp", "Dyscyplina_Zrodla")

    rok_range = range(2018, 2025)
    for elem in pbar(
        Dyscyplina_Zrodla.objects.all(), Dyscyplina_Zrodla.objects.count()
    ):
        # Migracja ustala rok dyscypliny domyslnie na 2017; teraz w tej procedurze
        # kopiujemy rok 2017 na 2018, 2019, 2020, 2021, 2022, 2023, 2024, celem
        # zachowania kompatybilnosci:
        # .create, bo zakładamy, że baza danych bedzie pusta w tym momencie
        Dyscyplina_Zrodla.objects.bulk_create(
            [
                Dyscyplina_Zrodla(
                    rok=rok, zrodlo_id=elem.zrodlo_id, dyscyplina_id=elem.dyscyplina_id
                )
                for rok in rok_range
            ]
        )


class Migration(migrations.Migration):
    dependencies = [
        ("bpp", "0351_uczelnia_pokazuj_autorow_bez_prac_w_przegladaniu_danych"),
    ]

    operations = [
        migrations.AddField(
            model_name="dyscyplina_zrodla",
            name="rok",
            field=models.IntegerField(default=2017),
            preserve_default=False,
        ),
        migrations.AlterUniqueTogether(
            name="dyscyplina_zrodla",
            unique_together={("zrodlo", "dyscyplina", "rok")},
        ),
        migrations.RunPython(skopiuj_dyscypliny_zrodel, migrations.RunPython.noop),
    ]
